unit Unit1;           // Euklidischer Algorithmus (modern und alt)
                      // mit Zeitmessung
                      // GN 28.3.2007
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Spin, ExtCtrls;

type
  TForm1 = class(TForm)
    LTitel: TLabel;
    LZahl1: TLabel;
    LZahl2: TLabel;
    LggT: TLabel;
    Eggt: TEdit;
    SpEZahl1: TSpinEdit;
    SpEZahl2: TSpinEdit;
    BZeitmessung: TButton;
    RGVerfahren: TRadioGroup;
    procedure Ergebnis(Sender: TObject);
    procedure BZeitmessungClick(Sender: TObject);
  private
    { Private-Deklarationen }
    function ggtAlt(a,b:integer):integer;
    function ggtNeu(a,b:integer):integer;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//-------- Model -------------------

function TForm1.ggtNeu(a,b:integer):integer;
// Euklid - moderne Variante
var r:integer;
begin
 repeat
  r:=a MOD b;
  a:=b;
  b:=r;
 until r=0;
result:=a;
end;

function TForm1.ggtAlt(a,b:integer):integer;
// Euklid - alte Variante
begin
 While a<>b do
   if a>b then a:=a-b
          else b:=b-a;
 result:=a;
end;

//-------- View + Controller -------------------

procedure TForm1.Ergebnis(Sender: TObject);
var a,b:integer;
begin
 a:=SpEZahl1.Value;
 b:=SpEZahl2.Value;
 if RGVerfahren.ItemIndex=0 then
    begin
    Form1.Caption:='ggT - Berechnung - alte Variante';
    Eggt.Text:=IntToStr(ggtAlt(a,b))
    end
  else
    begin
    Form1.Caption:='ggT - Berechnung - neue Variante';
    Eggt.Text:=IntToStr(ggtNeu(a,b));
    end;
end;

procedure TForm1.BZeitmessungClick(Sender: TObject);
var a, e, f: TLargeInteger;
begin
QueryPerformanceFrequency(f);
QueryPerformanceCounter(a);
Ergebnis(sender);
QueryPerformanceCounter(e);
BZeitmessung.Caption := FloatToStrF(1000*(e.QuadPart-a.QuadPart)/f.QuadPart,
                        FFNumber,8,3)+' ms';
end;

end.
