unit unit1;             // Kryptographie nach Caesar - mit Dateibehandlung
                        // Katharina Waerder V2.1, 28.09.2006
                        // GN 30.12.2006
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Spin;

type
  TForm1 = class(TForm)
    BKodieren: TButton;
    BDekodieren: TButton;
    BLoeschenKlar: TButton;
    BLoeschenGeheim: TButton;
    BLadenKlar: TButton;
    BSpeichernKlar: TButton;
    BLadenGeheim: TButton;
    BSpeichernGeheim: TButton;
    LKlartext: TLabel;
    LGeheimtext: TLabel;
    LSchluessel: TLabel;
    ImHintergrund: TImage;
    SpEdSchluessel: TSpinEdit;
    MKlartext: TMemo;
    MGeheimtext: TMemo;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    procedure BKodierenClick(Sender: TObject);
    procedure BDekodierenClick(Sender: TObject);
    procedure BLoeschenKlarClick(Sender: TObject);
    procedure BLoeschenGeheimClick(Sender: TObject);
    procedure BLadenKlarClick(Sender: TObject);
    procedure BSpeichernKlarClick(Sender: TObject);
    procedure BLadenGeheimClick(Sender: TObject);
    procedure BSpeichernGeheimClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
    klartext,
    geheimtext : String;
    key : integer;
    function klartextvorbereiten (klartext: string) : string;
    procedure entschluesseln;
    procedure verschluesseln;

  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//------ Model-------------------

function TForm1.klartextvorbereiten (klartext: string) : string;
var i: Integer;
    buchstabe:char;
    buchstaben_neu,klartext_vorbereitet:string;
begin
klartext:=AnsiUppercase(klartext);
klartext_vorbereitet:='';
for i:=1 to length(klartext) do
  begin
  buchstabe:=klartext[i];
  case buchstabe of  // Sonderbuchstaben ersetzen
       ''  : buchstaben_neu:= 'AE';
       ''  : buchstaben_neu:= 'OE';
       ''  : buchstaben_neu:= 'UE';
       ''  : buchstaben_neu:= 'SS';
     else           // ansonsten nur "normale" Buchstaben bernehmen
       if (buchstabe>='A') and (buchstabe<='Z') then
          buchstaben_neu:=buchstabe
        else
          buchstaben_neu:='';
     end;
  klartext_vorbereitet:=klartext_vorbereitet+buchstaben_neu;
  end;
result:=klartext_vorbereitet;
end;

procedure TForm1.verschluesseln;
var i,n : integer;
    c   : char;
begin
geheimtext:='';
klartext:=klartextvorbereiten (klartext);
for i:=1 to length(klartext) do
  begin
  c:=klartext[i];
  n:=ord(c);
  n:=n+key;
  if n>90 then n:=n-26;
  geheimtext:=geheimtext + chr(n);
  end;
end;

procedure TForm1.entschluesseln;
var i,n : Integer;
    c   : char;
begin
klartext:='';
for i:=1 to length(geheimtext) do
  begin
  c:=geheimtext[i];
  n:=ord(c);
  n:=n-key;
  if n<65 then n:=n+26;
  klartext:=klartext + chr(n);
  end;
end;

//------- View + Controller ----------------

procedure TForm1.BKodierenClick(Sender: TObject);
begin
key:=SpEdSchluessel.value;
klartext:=MKlartext.text;
verschluesseln;
MGeheimtext.text:=geheimtext;
end;

procedure TForm1.BDekodierenClick(Sender: TObject);
begin
key:=SpEdSchluessel.value;
geheimtext:=MGeheimtext.text;
entschluesseln;
MKlartext.text:=klartext;
end;

procedure TForm1.BLoeschenKlarClick(Sender: TObject);
begin
MKlartext.lines.clear;
end;

procedure TForm1.BLoeschenGeheimClick(Sender: TObject);
begin
MGeheimtext.lines.clear;
end;

procedure TForm1.BLadenKlarClick(Sender: TObject);
begin
if OpenDialog1.Execute then
MKlartext.Lines.LoadFromFile(OpenDialog1.Filename);
end;

procedure TForm1.BSpeichernKlarClick(Sender: TObject);
begin
if SaveDialog1.Execute then
MKlartext.Lines.SaveToFile(SaveDialog1.Filename);
end;

procedure TForm1.BLadenGeheimClick(Sender: TObject);
begin
if OpenDialog1.Execute then
MGeheimtext.Lines.LoadFromFile(OpenDialog1.Filename);
end;

procedure TForm1.BSpeichernGeheimClick(Sender: TObject);
begin
if SaveDialog1.Execute then
MGeheimtext.Lines.SaveToFile(SaveDialog1.Filename);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
SpEdSchluessel.value:=0;
end;

end.
