unit unit1;             // Sortieren einer Stringliste
                        // Katharina Waerder V2.1, 28.09.2006
                        // GN 30.12.2006
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

const max=10;

type
  TFeld  = array[0..max] of string;
  TForm1 = class(TForm)
    LTitel: TLabel;
    LEingabe: TLabel;
    LAusgabe: TLabel;
    BAuswahl: TButton;
    BNeueEingabe: TButton;
    LBAusgabe: TListBox;
    MEingabe: TMemo;
    LHinweis: TLabel;
    BEinfuegen: TButton;
    BBubble: TButton;
    BSorted: TButton;
    procedure SortierenClick(Sender: TObject);
    procedure BNeueEingabeClick(Sender: TObject);
    procedure MEingabeChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BSortedClick(Sender: TObject);

  private
    { Private-Deklarationen }
    verfahren:string;
    procedure a_sortieren(var feld:tfeld; laenge:integer);
    procedure b_sortieren(var feld:tfeld; laenge:integer);
    procedure e_sortieren(var feld:tfeld; laenge:integer);
  public
    { Public-Deklarationen }
  end;


var
  Form1: TForm1;

implementation

{$R *.DFM}

// ------- Model ---------------

procedure TForm1.a_sortieren(var feld:tfeld; laenge:integer);
var start,minpos,pos : integer;
    hilfe : string;
begin
verfahren:= 'Sortieren mit direkter Auswahl';
for start:=1 to laenge-1 do
  begin
  minpos:=start;                 // Minimumsuche
  for pos:=start+1 to laenge do
    if feld[pos]<feld[minpos] then minpos:=pos;
  hilfe:=feld[start];            // Tausch durchfhren
  feld[start]:=feld[minpos];
  feld[minpos]:=hilfe;
  end;
end;

procedure TForm1.b_sortieren(var feld:tfeld; laenge:integer);
var ende:boolean;
    pos : integer;
begin
verfahren:= 'Sortieren mit Bubblesort';
repeat
  ende:=true;
  for pos:=1 to laenge-1 do
    if feld[pos+1]<feld[pos] then
       begin
       feld[0]:=feld[pos];
       feld[pos]:=feld[pos+1];
       feld[pos+1]:=feld[0];
       ende:=false;
       end;
until ende;
end;

procedure TForm1.e_sortieren(var feld:tfeld; laenge:integer);
var pos,nr : integer;
begin
verfahren := 'Sortieren durch direktes Einfgen';
for nr:=2 to laenge do        //nr ist Position des key-Elements
  begin
  feld[0]:=feld[nr];	      //key-Element als Stopper
  pos:=nr-1;		      //Position des Vergleichselements
  while feld[0]<feld[pos] do  //Vergleiche mit key-Element
    begin
    feld[pos+1]:=feld[pos];   //Schiebe hoch
    pos:=pos-1;               //Vergleichspos. erniedrigen
    end;
  feld[pos+1]:=feld[0];       //Einfgen des key-Elements
  end;
end;

// -------- View + Controller -------------------

procedure TForm1.SortierenClick(Sender: TObject);

var feld:tfeld;
    anzahl, nr:integer;

begin
LBAusgabe.clear;
LBAusgabe.sorted:=false;
anzahl:=MEingabe.lines.count;       //Anzahl der Wrter
if anzahl > max then anzahl:=max;   //Maximalzahl der Wrter
for nr:=1 to anzahl do feld[nr]:=MEingabe.lines.strings[nr-1];

if sender=BAuswahl then
   begin
   LBAusgabe.Font.Color:=clblack;
   a_sortieren(feld,anzahl);
   LTitel.Caption:=verfahren;
   end;
if sender=BEinfuegen then
   begin
   LBAusgabe.Font.Color:=clblue;
   e_sortieren(feld,anzahl);
   LTitel.Caption:=verfahren;
   end;
if sender=BBubble then
   begin
   LBAusgabe.Font.Color:=clred;
   b_sortieren(feld,anzahl);
   LTitel.Caption:=verfahren;
   end;

for nr:=1 to anzahl do LBAusgabe.items.add(feld[nr]);
end;

procedure TForm1.BNeueEingabeClick(Sender: TObject);
begin
MEingabe.clear;
LBAusgabe.clear;
end;

procedure TForm1.MEingabeChange(Sender: TObject);
begin
LBAusgabe.clear;
if MEingabe.lines.count>max then
   begin
   LHinweis.visible:=true;
   LHinweis.caption:='Nur die ersten '+IntToStr(max)+' Wrter werden sortiert!'
   end
 else
   LHinweis.visible:=false;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
LTitel.Caption:='Sortieren';
end;

procedure TForm1.BSortedClick(Sender: TObject);
begin
LTitel.Caption:='Sortierverfahren von Delphi';
LBAusgabe.sorted:=true;
end;

end.

